
#include-once
#include 'Header.au3'
#include 'Vec3f.au3'
#include 'Geometry.au3'

; NumericLimits.au3
Global Const $INT32_MIN   = -2147483648 ; Hinweis: $INT32_MIN - 1 wird automatisch zu INT64 gecastet.
Global Const $INT32_MAX   =  2147483647 ; Hinweis: $INT32_MAX + 1 wird automatisch zu INT64 gecastet.
Global Const $INT64_MIN   = -9223372036854775808
Global Const $INT64_MAX   =  9223372036854775807
Global Const $DOUBLE_MIN  =  1e-308 ; Hinweis: Das sind nicht die "echten" MinMax Werte, da diese AutoIt intern anders verarbeitet werden.
Global Const $DOUBLE_MAX  =  1e+308 ; Min, Max, TrueMin, TrueMax, Low etc. konnte ich nicht herausfinden. (2.5e-324 = 5e-324) = True!
Global Const $DOUBLE_NMIN = -1e-308
Global Const $DOUBLE_NMAX = -1e+308
Global Const $SRANDOM_MIN = -2147483648 ; Hinweis: SRandom verwendet intern einen Modulo. SRandom($SRANDOM_MAX + 1) = SRandom($SRANDOM_MIN)
Global Const $SRANDOM_MAX =  2147483647 ;

;~ #include 'C:\Users\pluto\OneDrive\AutoIt\UDF\NumericLimits.au3'

#include <Array.au3>
#include <GDIPlus.au3>

Opt('MustDeclareVars', 1)

If @ScriptName = 'A3D.au3' Then __A3D_GeometryExample()

Func __A3D_GeometryExample()
	Local $aSphere = _GeometryIcosahedron($GEO_TYPE_TRIANGLE)
	_GeometrySubdiv($aSphere)
	_GeometryProjectOnSphere($aSphere, 0.5)
	_GeometryTranslate($aSphere, 1, -1.25, 1)
	ConsoleWrite(_GeometryToOFF($aSphere))
EndFunc   ;==>__A3D_GeometryExample


Func A3D_Init() ; Alles was nur 1x gemacht werden muss... also aktuell absolut überhauptnichts...

EndFunc   ;==>A3D_Init

Func A3D_BeginScene()
	$A3D_DVA_COUNT = 0
	$A3D_DPA_COUNT = 0
	$A3D_DLA_COUNT = 0
	$A3D_DTA_COUNT = 0
	$A3D_DQA_COUNT = 0
EndFunc   ;==>A3D_BeginScene

Func __A3D_GetNextObject() ; Eine Art Mergesort mit 4 Listen. Ist nicht gut, da hier sehr viel verglichen werden muss, Laufzeit für nächstes Obj ist Const, aber viel zu groß.
	Local $PZ = $A3D_DPZ_INDEX >= $A3D_DPZ_COUNT ? $DOUBLE_NMAX : $A3D_DPZ[$A3D_DPZ_INDEX][1]
	Local $LZ = $A3D_DLZ_INDEX >= $A3D_DLZ_COUNT ? $DOUBLE_NMAX : $A3D_DLZ[$A3D_DLZ_INDEX][1]
	Local $TZ = $A3D_DTZ_INDEX >= $A3D_DTZ_COUNT ? $DOUBLE_NMAX : $A3D_DTZ[$A3D_DTZ_INDEX][1]
	Local $QZ = $A3D_DQZ_INDEX >= $A3D_DQZ_COUNT ? $DOUBLE_NMAX : $A3D_DQZ[$A3D_DQZ_INDEX][1] ; Sorry, die Methode ist doof, aber das ist die schnellste Version dieser doofen Methode...
	Return ($PZ = $DOUBLE_NMAX And $TZ = $DOUBLE_NMAX And $QZ = $DOUBLE_NMAX And $LZ = $DOUBLE_NMAX) ? $GEO_TYPE_NONE : $PZ > $LZ ? $TZ > $QZ ? $PZ > $TZ ? 1 : 3 : $PZ > $QZ ? 1 : 4 : $TZ > $QZ ? $LZ > $TZ ? 2 : 3 : $LZ > $QZ ? 2 : 4
EndFunc   ;==>__A3D_GetNextObject

Func A3D_EndScene($hGFX)
	; Hier wird gerendert

	; Alle Arrays auf -1, 1 abbilden
	; rauswerfen was nicht angezeigt wird (passiert in UpdateXXXZ)
	; Alles nach z sortieren
	; Rückwärts aufbauen und alle Arrays gucken welches das beste z hat bis alle Arrays abgearbeitet sind. TODO

	Local $hPEN = _GDIPlus_PenCreate(0xFF8080EE, 2)
	_GDIPlus_PenSetLineJoin($hPEN, 2)
	Local $hBRU = _GDIPlus_BrushCreateSolid(0xFF808080)

	Local $_

;~ 	$_ = TimerInit()
	__A3D_UpdatePointZ()
;~ 	$_ = TimerDiff($_)
;~ 	ConsoleWrite('UpdatePointZ: ' & StringFormat('%.4f', $_) & @CRLF)

	__A3D_UpdateLineZ()
;~ 	$_ = TimerInit()
	__A3D_UpdateTriangleNZ()
;~ 	$_ = TimerDiff($_)
;~ 	ConsoleWrite('UpdateTriangleZ: ' & StringFormat('%.4f', $_) & @CRLF)
;~ 	$_ = TimerInit()
	__A3D_UpdateQuadNZ()
;~ 	$_ = TimerDiff($_)
;~ 	ConsoleWrite('UpdateQuadZ: ' & StringFormat('%.4f', $_) & @CRLF)

	$A3D_DPZ_INDEX = 0
	$A3D_DLZ_INDEX = 0
	$A3D_DTZ_INDEX = 0
	$A3D_DQZ_INDEX = 0

	Local $hMAT = DllCall($__g_hGDIPDll, 'int', 'GdipCreateMatrix2', 'float', $A3D_WIDTH / 2, 'float', 0, 'float', 0, 'float', $A3D_HEIGHT / 2, 'float', $A3D_WIDTH / 2, 'float', $A3D_HEIGHT / 2, 'handle*', 0)[7]
	DllCall($__g_hGDIPDll, 'int', 'GdipSetWorldTransform', 'handle', $hGFX, 'handle', $hMAT)

	Local $O = 0, $O1 = 0, $O2 = 0, $O3 = 0, $O4 = 0
	Local $tPoints = DllStructCreate('float x1;float y1;float x2;float y2;float x3;float y3;float x4;float y4;')
	While True
		Switch __A3D_GetNextObject()
			Case $GEO_TYPE_NONE
				ExitLoop
			Case $GEO_TYPE_POINT
				$O = $A3D_DPZ[$A3D_DPZ_INDEX][0]
				$O1 = $A3D_DPA[$O][0] * 3
				DllCall($__g_hGDIPDll, "int", "GdipSetSolidFillColor", "handle", $hBRU, "dword", _ColorAI_HSL2RGB($A3D_DPA[$O][1]))
				DllCall($__g_hGDIPDll, 'int', 'GdipFillEllipse', 'handle', $hGFX, 'handle', $hBRU, 'float', $A3D_DVA[$O1][0] - 0.01, 'float', $A3D_DVA[$O1][1] - 0.01, 'float', 0.02, 'float', 0.02)
				$A3D_DPZ_INDEX += 1
;~ 				ConsoleWrite($A3D_DPZ_INDEX & @CRLF)
			Case $GEO_TYPE_LINE ; not implemented yet
				$O = $A3D_DLZ[$A3D_DLZ_INDEX][0]
				$O1 = $A3D_DLA[$O][0] * 3
				$O2 = $A3D_DLA[$O][1] * 3
				DllCall($__g_hGDIPDll, 'int', 'GdipSetPenColor', 'handle', $hPEN, 'dword', _ColorAI_HSL2RGB($A3D_DLA[$O][2]))
				DllCall($__g_hGDIPDll, 'int', 'GdipDrawLine', 'handle', $hGFX, 'handle', $hPEN, 'float', $A3D_DVA[$O1][0], 'float', $A3D_DVA[$O1][1], 'float', $A3D_DVA[$O2][0], 'float', $A3D_DVA[$O2][1])

				$A3D_DLZ_INDEX += 1

			Case $GEO_TYPE_TRIANGLE
				$O = $A3D_DTZ[$A3D_DTZ_INDEX][0]

				$O1 = $A3D_DTA[$O][0] * 3
				$O2 = $A3D_DTA[$O][1] * 3
				$O3 = $A3D_DTA[$O][2] * 3
				Local $aHSL = $A3D_DTA[$O][3]

				Local $angle = $A3D_DRAW_TRIANGLENORMALS[$O * 3] * $A3D_LN[0] + $A3D_DRAW_TRIANGLENORMALS[$O * 3 + 1] * $A3D_LN[1] + $A3D_DRAW_TRIANGLENORMALS[$O * 3 + 2] * $A3D_LN[2]
				$aHSL[2] = 0.15 + 0.35 * $angle + 0.2 * $angle ^ 16

				DllCall($__g_hGDIPDll, "int", "GdipSetSolidFillColor", "handle", $hBRU, "dword", _ColorAI_HSL2RGB($aHSL))

				$tPoints.x1 = $A3D_DVA[$O1][0]
				$tPoints.y1 = $A3D_DVA[$O1][1]
				$tPoints.x2 = $A3D_DVA[$O2][0]
				$tPoints.y2 = $A3D_DVA[$O2][1]
				$tPoints.x3 = $A3D_DVA[$O3][0]
				$tPoints.y3 = $A3D_DVA[$O3][1]

				DllCall($__g_hGDIPDll, 'int', 'GdipFillPolygon', 'handle', $hGFX, 'handle', $hBRU, 'struct*', $tPoints, 'int', 3, 'int', 'FillModeAlternate')

				$A3D_DTZ_INDEX += 1

			Case $GEO_TYPE_QUAD
				$O = $A3D_DQZ[$A3D_DQZ_INDEX][0]
				$O1 = $A3D_DQA[$O][0] * 3
				$O2 = $A3D_DQA[$O][1] * 3
				$O3 = $A3D_DQA[$O][2] * 3
				$O4 = $A3D_DQA[$O][3] * 3
				Local $aHSL = $A3D_DQA[$O][4]

				Local $angle = $A3D_DRAW_QUADNORMALS[$O * 3] * $A3D_LN[0] + $A3D_DRAW_QUADNORMALS[$O * 3 + 1] * $A3D_LN[1] + $A3D_DRAW_QUADNORMALS[$O * 3 + 2] * $A3D_LN[2]
				$aHSL[2] = 0.15 + 0.35 * $angle + 0.2 * $angle ^ 16

				DllCall($__g_hGDIPDll, "int", "GdipSetSolidFillColor", "handle", $hBRU, "dword", _ColorAI_HSL2RGB($aHSL))

				$tPoints.x1 = $A3D_DVA[$O1][0]
				$tPoints.y1 = $A3D_DVA[$O1][1]
				$tPoints.x2 = $A3D_DVA[$O2][0]
				$tPoints.y2 = $A3D_DVA[$O2][1]
				$tPoints.x3 = $A3D_DVA[$O3][0]
				$tPoints.y3 = $A3D_DVA[$O3][1]
				$tPoints.x4 = $A3D_DVA[$O4][0]
				$tPoints.y4 = $A3D_DVA[$O4][1]

				DllCall($__g_hGDIPDll, 'int', 'GdipFillPolygon', 'handle', $hGFX, 'handle', $hBRU, 'struct*', $tPoints, 'int', 4, 'int', 'FillModeAlternate')

				$A3D_DQZ_INDEX += 1

		EndSwitch
	WEnd

	_GDIPlus_GraphicsResetTransform($hGFX)
	_GDIPlus_MatrixDispose($hMAT)
	_GDIPlus_BrushDispose($hBRU)
	_GDIPlus_PenDispose($hPEN)

EndFunc   ;==>A3D_EndScene


Func A3D_MatrixPush()
	$A3D_MATRIXSTACK[$A3D_MATRIXSTACK_COUNT] = $A3D_DRAW_MATRIX
	$A3D_MATRIXSTACK_COUNT += 1
EndFunc   ;==>A3D_MatrixPush

Func A3D_MatrixPop()
	$A3D_MATRIXSTACK_COUNT -= 1
	$A3D_DRAW_MATRIX = $A3D_MATRIXSTACK[$A3D_MATRIXSTACK_COUNT]
EndFunc   ;==>A3D_MatrixPop

Func A3D_MatrixTranslate($dx, $dy, $dz) ; TODO Ausschreiben zum optimieren.
	Local $_ = [ _
			[1, 0, 0, $dx], _
			[0, 1, 0, $dy], _
			[0, 0, 1, $dz], _
			[0, 0, 0, 1]]
	$A3D_DRAW_MATRIX = __A3D_MatrixMultiply($A3D_DRAW_MATRIX, $_)
EndFunc   ;==>A3D_MatrixTranslate

Func A3D_MatrixRotate($ax, $ay, $az) ; erst um x achse, dann um y achse, dann um z achse
	Local $_ = [ _
			[1, 0, 0, 0], _
			[0, Cos($ax), -Sin($ax), 0], _
			[0, Sin($ax), Cos($ax), 0], _
			[0, 0, 0, 1]]
	$A3D_DRAW_MATRIX = __A3D_MatrixMultiply($A3D_DRAW_MATRIX, $_)
	Local $_ = [ _
			[Cos($ay), 0, Sin($ay), 0], _
			[0, 1, 0, 0], _
			[-Sin($ay), 0, Cos($ay), 0], _
			[0, 0, 0, 1]]
	$A3D_DRAW_MATRIX = __A3D_MatrixMultiply($A3D_DRAW_MATRIX, $_)
	Local $_ = [ _
			[Cos($az), -Sin($az), 0, 0], _
			[Sin($az), Cos($az), 0, 0], _
			[0, 0, 1, 0], _
			[0, 0, 0, 1]]
	$A3D_DRAW_MATRIX = __A3D_MatrixMultiply($A3D_DRAW_MATRIX, $_)
EndFunc   ;==>A3D_MatrixRotate

Func __A3D_MatrixMultiply(ByRef $A, ByRef $B) ; Die vollständige Matrixmultiplikation sollte man möglichst selten machen. Wird aktuell 1x pro Objekt pro Frame gemacht (nötig, da Objekte eigene Trafos haben)
	Local $_ = [ _
			[$A[0][0] * $B[0][0] + $A[0][1] * $B[1][0] + $A[0][2] * $B[2][0] + $A[0][3] * $B[3][0], _
			$A[0][0] * $B[0][1] + $A[0][1] * $B[1][1] + $A[0][2] * $B[2][1] + $A[0][3] * $B[3][1], _
			$A[0][0] * $B[0][2] + $A[0][1] * $B[1][2] + $A[0][2] * $B[2][2] + $A[0][3] * $B[3][2], _
			$A[0][0] * $B[0][3] + $A[0][1] * $B[1][3] + $A[0][2] * $B[2][3] + $A[0][3] * $B[3][3]], _
			[$A[1][0] * $B[0][0] + $A[1][1] * $B[1][0] + $A[1][2] * $B[2][0] + $A[1][3] * $B[3][0], _
			$A[1][0] * $B[0][1] + $A[1][1] * $B[1][1] + $A[1][2] * $B[2][1] + $A[1][3] * $B[3][1], _
			$A[1][0] * $B[0][2] + $A[1][1] * $B[1][2] + $A[1][2] * $B[2][2] + $A[1][3] * $B[3][2], _
			$A[1][0] * $B[0][3] + $A[1][1] * $B[1][3] + $A[1][2] * $B[2][3] + $A[1][3] * $B[3][3]], _
			[$A[2][0] * $B[0][0] + $A[2][1] * $B[1][0] + $A[2][2] * $B[2][0] + $A[2][3] * $B[3][0], _
			$A[2][0] * $B[0][1] + $A[2][1] * $B[1][1] + $A[2][2] * $B[2][1] + $A[2][3] * $B[3][1], _
			$A[2][0] * $B[0][2] + $A[2][1] * $B[1][2] + $A[2][2] * $B[2][2] + $A[2][3] * $B[3][2], _
			$A[2][0] * $B[0][3] + $A[2][1] * $B[1][3] + $A[2][2] * $B[2][3] + $A[2][3] * $B[3][3]], _
			[$A[3][0] * $B[0][0] + $A[3][1] * $B[1][0] + $A[3][2] * $B[2][0] + $A[3][3] * $B[3][0], _
			$A[3][0] * $B[0][1] + $A[3][1] * $B[1][1] + $A[3][2] * $B[2][1] + $A[3][3] * $B[3][1], _
			$A[3][0] * $B[0][2] + $A[3][1] * $B[1][2] + $A[3][2] * $B[2][2] + $A[3][3] * $B[3][2], _
			$A[3][0] * $B[0][3] + $A[3][1] * $B[1][3] + $A[3][2] * $B[2][3] + $A[3][3] * $B[3][3]]]
	Return $_
EndFunc   ;==>__A3D_MatrixMultiply

Func __A3D_MatrixMultiplyXYZ(ByRef $A, ByRef $x, ByRef $y, ByRef $z)
	Local $d = $A[3][0] * $x + $A[3][1] * $y + $A[3][2] * $z + $A[3][3]
	Local $_ = [ _
			($A[0][0] * $x + $A[0][1] * $y + $A[0][2] * $z + $A[0][3]) / $d, _
			($A[1][0] * $x + $A[1][1] * $y + $A[1][2] * $z + $A[1][3]) / $d, _
			($A[2][0] * $x + $A[2][1] * $y + $A[2][2] * $z + $A[2][3]) / $d]
	Return $_
EndFunc   ;==>__A3D_MatrixMultiplyXYZ

Func A3D_GeometryDraw(ByRef $aGeo)
	; $aGeo[2]
	; [0] = Vertexlist[n][3]
	; [1] = Indexlist[n][i] -> i = 1 Point, i = 2 Line, i = 3 Triangle, i = 4 Quad
	__A3D_VerticesInsertIntoDRAW($aGeo[0]) ; Vertices hinzufügen.
	Switch UBound($aGeo[1], 2)
		Case $GEO_TYPE_POINT
			__A3D_GeometryDrawP($aGeo)
		Case $GEO_TYPE_LINE
			__A3D_GeometryDrawL($aGeo)
		Case $GEO_TYPE_TRIANGLE
			__A3D_GeometryDrawT($aGeo)
		Case $GEO_TYPE_QUAD
			__A3D_GeometryDrawQ($aGeo)
	EndSwitch
EndFunc   ;==>A3D_GeometryDraw

Func __A3D_GeometryDrawP(ByRef $aGeo)
	Local $aIndices = $aGeo[1], $_ = $A3D_DVA_COUNT
	For $i = 0 To UBound($aIndices) - 1 Step 1
		If $A3D_DVA[$_ + $aIndices[$i][0]][0] = Null Then ContinueLoop
		$A3D_DPA[$A3D_DPA_COUNT][0] = $_ + $aIndices[$i][0]
		$A3D_DPA[$A3D_DPA_COUNT][1] = $A3D_COLOR_DEFAULT_POINT
		$A3D_DPA_COUNT += 1
	Next
	$A3D_DVA_COUNT += UBound($aGeo[0])
EndFunc   ;==>__A3D_GeometryDrawP

Func __A3D_GeometryDrawQ(ByRef $aGeo)
	If UBound($aGeo[2]) = 0 Then
		__A3D_IndicesInsertIntoDRAWQ($aGeo[1])
	Else
		__A3D_IndicesInsertIntoDRAWQC($aGeo[1], $aGeo[2])
	EndIf
	$A3D_DVA_COUNT += UBound($aGeo[0])
EndFunc   ;==>__A3D_GeometryDrawQ

Func __A3D_GeometryDrawT(ByRef $aGeo)
	If UBound($aGeo[2]) = 0 Then
		__A3D_IndicesInsertIntoDRAWT($aGeo[1])
	Else
		__A3D_IndicesInsertIntoDRAWTC($aGeo[1], $aGeo[2])
	EndIf
	$A3D_DVA_COUNT += UBound($aGeo[0])
EndFunc   ;==>__A3D_GeometryDrawT

Func __A3D_IndicesInsertIntoDRAWQ(ByRef $aIndices)
	Local $_ = $A3D_DVA_COUNT
	For $i = 0 To UBound($aIndices) - 1 Step 1
		If $A3D_DVA[($_ + $aIndices[$i][0]) * 3][0] = Null Or $A3D_DVA[($_ + $aIndices[$i][1]) * 3][0] = Null Or $A3D_DVA[($_ + $aIndices[$i][2]) * 3][0] = Null  Or $A3D_DVA[($_ + $aIndices[$i][3]) * 3][0] = Null Then ContinueLoop
		$A3D_DQA[$A3D_DQA_COUNT][0] = $_ + $aIndices[$i][0]
		$A3D_DQA[$A3D_DQA_COUNT][1] = $_ + $aIndices[$i][1]
		$A3D_DQA[$A3D_DQA_COUNT][2] = $_ + $aIndices[$i][2]
		$A3D_DQA[$A3D_DQA_COUNT][3] = $_ + $aIndices[$i][3]
		$A3D_DQA[$A3D_DQA_COUNT][4] = $A3D_COLOR_DEFAULT_QUAD
		$A3D_DQA_COUNT += 1
	Next
EndFunc

Func __A3D_IndicesInsertIntoDRAWQC(ByRef $aIndices, ByRef $aColors)
	Local $_ = $A3D_DVA_COUNT
	For $i = 0 To UBound($aIndices) - 1 Step 1
		If $A3D_DVA[($_ + $aIndices[$i][0]) * 3][0] = Null Or $A3D_DVA[($_ + $aIndices[$i][1]) * 3][0] = Null Or $A3D_DVA[($_ + $aIndices[$i][2]) * 3][0] = Null  Or $A3D_DVA[($_ + $aIndices[$i][3]) * 3][0] = Null Then ContinueLoop
		$A3D_DQA[$A3D_DQA_COUNT][0] = $_ + $aIndices[$i][0]
		$A3D_DQA[$A3D_DQA_COUNT][1] = $_ + $aIndices[$i][1]
		$A3D_DQA[$A3D_DQA_COUNT][2] = $_ + $aIndices[$i][2]
		$A3D_DQA[$A3D_DQA_COUNT][3] = $_ + $aIndices[$i][3]
		$A3D_DQA[$A3D_DQA_COUNT][4] = $aColors[$i]
		$A3D_DQA_COUNT += 1
	Next
EndFunc

Func __A3D_IndicesInsertIntoDRAWT(ByRef $aIndices)
	Local $_ = $A3D_DVA_COUNT
	For $i = 0 To UBound($aIndices) - 1 Step 1
		If $A3D_DVA[($_ + $aIndices[$i][0]) * 3][0] = Null Or $A3D_DVA[($_ + $aIndices[$i][1]) * 3][0] = Null Or $A3D_DVA[($_ + $aIndices[$i][2]) * 3][0] = Null Then ContinueLoop
		$A3D_DTA[$A3D_DTA_COUNT][0] = $_ + $aIndices[$i][0]
		$A3D_DTA[$A3D_DTA_COUNT][1] = $_ + $aIndices[$i][1]
		$A3D_DTA[$A3D_DTA_COUNT][2] = $_ + $aIndices[$i][2]
		$A3D_DTA[$A3D_DTA_COUNT][3] = $A3D_COLOR_DEFAULT_TRIANGLE
		$A3D_DTA_COUNT += 1
	Next
EndFunc

Func __A3D_IndicesInsertIntoDRAWTC(ByRef $aIndices, ByRef $aColors)
	Local $_ = $A3D_DVA_COUNT
	For $i = 0 To UBound($aIndices) - 1 Step 1
		If $A3D_DVA[($_ + $aIndices[$i][0]) * 3][0] = Null Or $A3D_DVA[($_ + $aIndices[$i][1]) * 3][0] = Null Or $A3D_DVA[($_ + $aIndices[$i][2]) * 3][0] = Null Then ContinueLoop
		$A3D_DTA[$A3D_DTA_COUNT][0] = $_ + $aIndices[$i][0]
		$A3D_DTA[$A3D_DTA_COUNT][1] = $_ + $aIndices[$i][1]
		$A3D_DTA[$A3D_DTA_COUNT][2] = $_ + $aIndices[$i][2]
		$A3D_DTA[$A3D_DTA_COUNT][3] = $aColors[$i]
		$A3D_DTA_COUNT += 1
	Next
EndFunc

Func __A3D_GeometryDrawL(ByRef $aGeo)
	Local $aIndices = $aGeo[1], $_ = $A3D_DVA_COUNT
	For $i = 0 To UBound($aIndices) - 1 Step 1
		If $A3D_DVA[($_ + $aIndices[$i][0]) * 3][0] = Null Or $A3D_DVA[($_ + $aIndices[$i][1]) * 3][0] = Null Then ContinueLoop
		$A3D_DLA[$A3D_DLA_COUNT][0] = $_ + $aIndices[$i][0]
		$A3D_DLA[$A3D_DLA_COUNT][1] = $_ + $aIndices[$i][1]
		$A3D_DLA[$A3D_DLA_COUNT][2] = $A3D_COLOR_DEFAULT_LINE
		$A3D_DLA_COUNT += 1
	Next
	$A3D_DVA_COUNT += UBound($aGeo[0])
EndFunc   ;==>__A3D_GeometryDrawL

Func __A3D_VerticesInsertIntoDRAW(ByRef $aV3)
	Local $_ = $A3D_DVA_COUNT, $M2 = __A3D_MatrixMultiply($A3D_PROJECTIONMATRIX, $A3D_DRAW_MATRIX)
	For $i = 0 To UBound($aV3) - 1 Step 1
		Local $aVec3f = __A3D_MatrixMultiplyXYZ($M2, $aV3[$i][0], $aV3[$i][1], $aV3[$i][2])
		If $aVec3f[2] < -$A3D_CLIPNEAR And $aVec3f[2] > -$A3D_CLIPFAR Then
			$A3D_DVA[($_ + $i) * 3][0] = $aVec3f[0]
			$A3D_DVA[($_ + $i) * 3][1] = $aVec3f[1]
			$A3D_DVA[($_ + $i) * 3][2] = $aVec3f[2]
		Else
			$A3D_DVA[($_ + $i) * 3][0] = Null
;~ 			$A3D_DVA[($_ + $i) * 3 + 1] = Null
;~ 			$A3D_DVA[($_ + $i) * 3 + 2] = Null
		EndIf
	Next
;~ 	$A3D_DVA_COUNT += UBound($aV3)
EndFunc   ;==>__A3D_VerticesInsertIntoDRAW


Func __A3D_UpdatePointZ()
	Local $P1 = 0.0
	$A3D_DPZ_COUNT = 0
	For $P = 0 To $A3D_DPA_COUNT - 1 Step 1
		$P1 = $A3D_DPA[$P][0] * 3
		$A3D_DPZ[$A3D_DPZ_COUNT][0] = $P
		$A3D_DPZ[$A3D_DPZ_COUNT][1] = $A3D_DVA[$P1][2] ; z Wert bei +2
		$A3D_DPZ_COUNT += 1
	Next
	If $A3D_DPZ_COUNT > 1 Then _ArraySort($A3D_DPZ, 1, 0, $A3D_DPZ_COUNT - 1, 1)
EndFunc   ;==>__A3D_UpdatePointZ

Func __A3D_UpdateLineZ()
	Local $L1 = 0, $L2 = 0
	$A3D_DLZ_COUNT = 0
	For $L = 0 To $A3D_DLA_COUNT - 1 Step 1
		$L1 = $A3D_DLA[$L][0] * 3
		$L2 = $A3D_DLA[$L][1] * 3
		$A3D_DLZ[$A3D_DLZ_COUNT][0] = $L
		$A3D_DLZ[$A3D_DLZ_COUNT][1] = ($A3D_DVA[$L1][2] + $A3D_DVA[$L2][2]) / 2
		$A3D_DLZ_COUNT += 1
	Next
	If $A3D_DLZ_COUNT > 1 Then _ArraySort($A3D_DLZ, 1, 0, $A3D_DLZ_COUNT - 1, 1)
EndFunc   ;==>__A3D_UpdateLineZ

Func __A3D_UpdateTriangleNZ()
	Local $_ = 0.0, $T1 = 0, $T2 = 0, $T3 = 0
	$A3D_DTZ_COUNT = 0
	For $t = 0 To $A3D_DTA_COUNT - 1 Step 1
		$T1 = $A3D_DTA[$t][0] * 3
		$T2 = $A3D_DTA[$t][1] * 3
		$T3 = $A3D_DTA[$t][2] * 3

		Local $aVec3f_1 = [$A3D_DVA[$T1][0], $A3D_DVA[$T1][1], $A3D_DVA[$T1][2]]
		Local $aVec3f_2 = [$A3D_DVA[$T2][0], $A3D_DVA[$T2][1], $A3D_DVA[$T2][2]]
		Local $aVec3f_3 = [$A3D_DVA[$T3][0], $A3D_DVA[$T3][1], $A3D_DVA[$T3][2]]
		Local $aVec3f_n = Vec3fCrossTriangle($aVec3f_1, $aVec3f_2, $aVec3f_3)
		$_ = Sqrt($aVec3f_n[0] * $aVec3f_n[0] + $aVec3f_n[1] * $aVec3f_n[1] + $aVec3f_n[2] * $aVec3f_n[2])
		$A3D_DRAW_TRIANGLENORMALS[$t * 3] = $aVec3f_n[0] / $_
		$A3D_DRAW_TRIANGLENORMALS[$t * 3 + 1] = $aVec3f_n[1] / $_
		$A3D_DRAW_TRIANGLENORMALS[$t * 3 + 2] = $aVec3f_n[2] / $_
		If ACos($A3D_DRAW_TRIANGLENORMALS[$t * 3] * $A3D_CN[0] + $A3D_DRAW_TRIANGLENORMALS[$t * 3 + 1] * $A3D_CN[1] + $A3D_DRAW_TRIANGLENORMALS[$t * 3 + 2] * $A3D_CN[2]) < 1.570796327 Then
			$A3D_DTZ[$A3D_DTZ_COUNT][0] = $t
			$A3D_DTZ[$A3D_DTZ_COUNT][1] = ($aVec3f_1[2] + $aVec3f_2[2] + $aVec3f_3[2]) / 3
			$A3D_DTZ_COUNT += 1
		EndIf
	Next
	If $A3D_DTZ_COUNT > 1 Then _ArraySort($A3D_DTZ, 1, 0, $A3D_DTZ_COUNT - 1, 1)
EndFunc   ;==>__A3D_UpdateTriangleNZ

Func __A3D_UpdateQuadNZ() ; TODO: Rechnung ist aktuell noch identisch zum Triangle
	; Z-Buffer Teil (kann man optimieren)
	Local $_ = 0.0, $Q1 = 0, $Q2 = 0, $Q3 = 0
	$A3D_DQZ_COUNT = 0
	For $Q = 0 To $A3D_DQA_COUNT - 1 Step 1
		$Q1 = $A3D_DQA[$Q][0] * 3     ; hier ist *4, weil 4 vtx = 1 Quad, außerdem *3 weil xyz
		$Q2 = $A3D_DQA[$Q][1] * 3
		$Q3 = $A3D_DQA[$Q][2] * 3
		Local $aVec3f_1 = [$A3D_DVA[$Q1][0], $A3D_DVA[$Q1][1], $A3D_DVA[$Q1][2]]
		Local $aVec3f_2 = [$A3D_DVA[$Q2][0], $A3D_DVA[$Q2][1], $A3D_DVA[$Q2][2]]
		Local $aVec3f_3 = [$A3D_DVA[$Q3][0], $A3D_DVA[$Q3][1], $A3D_DVA[$Q3][2]]
		Local $aVec3f_n = Vec3fCrossTriangle($aVec3f_1, $aVec3f_2, $aVec3f_3)
		$_ = Sqrt($aVec3f_n[0] * $aVec3f_n[0] + $aVec3f_n[1] * $aVec3f_n[1] + $aVec3f_n[2] * $aVec3f_n[2])
		$A3D_DRAW_QUADNORMALS[$Q * 3] = $aVec3f_n[0] / $_
		$A3D_DRAW_QUADNORMALS[$Q * 3 + 1] = $aVec3f_n[1] / $_
		$A3D_DRAW_QUADNORMALS[$Q * 3 + 2] = $aVec3f_n[2] / $_
		If ACos($A3D_DRAW_QUADNORMALS[$Q * 3] * $A3D_CN[0] + $A3D_DRAW_QUADNORMALS[$Q * 3 + 1] * $A3D_CN[1] + $A3D_DRAW_QUADNORMALS[$Q * 3 + 2] * $A3D_CN[2]) < 1.570796327 Then
			$A3D_DQZ[$A3D_DQZ_COUNT][0] = $Q
			$A3D_DQZ[$A3D_DQZ_COUNT][1] = ($A3D_DVA[$Q1][2] + $A3D_DVA[$Q3][2]) / 2 ; halbe Diagonale. Ist nur für Flache symmetrische Quads richtig. sonst etwas schepp.
			$A3D_DQZ_COUNT += 1
		EndIf
	Next
	If $A3D_DQZ_COUNT > 1 Then _ArraySort($A3D_DQZ, 1, 0, $A3D_DQZ_COUNT - 1, 1)
EndFunc   ;==>__A3D_UpdateQuadNZ


