#include-once

; Funktionen zum schnellen Umrechnen zwischen HSL und RGB
; Mars



;~ #include <Array.au3>

;~ Local $a = _ColorIA_RGB2HSL(0xFF8CBAE1)
;~ _ArrayDisplay($a)

;~ ConsoleWrite(_ColorAI_HSL2RGB($a) & @CRLF)

; #FUNCTION# ====================================================================================================================
; Author ........: Mars
; Modified.......: das ist peak AutoIt, hier wird nicht modifiziert
; Description....: Input: float HSL[3], Output: float RGB[3]
; ===============================================================================================================================
Func _ColorAA_HSL2RGB($a)
	Local $c = (1-Abs(2*$a[2]-1))*$a[1], $m = $a[2] - $c/2, $x = $c * (1 - Abs(($a[0] * 3 - Int($a[0] * 3))*2-1)), $R = [$m, $m, $m]
	Switch Int($a[0] * 6)
		Case 0
			$R[0] += $c
			$R[1] += $x
		Case 1
			$R[0] += $x
			$R[1] += $c
		Case 2
			$R[1] += $c
			$R[2] += $x
		Case 3
			$R[1] += $x
			$R[2] += $c
		Case 4
			$R[0] += $x
			$R[2] += $c
		Case Else
			$R[0] += $c
			$R[2] += $x
	EndSwitch
	Return $R
EndFunc

; #FUNCTION# ====================================================================================================================
; Author ........: Mars
; Modified.......: das ist peak AutoIt, hier wird nicht modifiziert
; Description....: Input: float HSL[3], Output: Int32 0xFFRRGGBB
; ===============================================================================================================================
Func _ColorAI_HSL2RGB($a)
	Local $c = (1-Abs(2*$a[2]-1))*$a[1], $m = $a[2] - $c/2, $x = $c * (1 - Abs(($a[0] * 3 - Int($a[0] * 3))*2-1)), $R = [$m, $m, $m]
	Switch Int($a[0] * 6)
		Case 0
			$R[0] += $c
			$R[1] += $x
		Case 1
			$R[0] += $x
			$R[1] += $c
		Case 2
			$R[1] += $c
			$R[2] += $x
		Case 3
			$R[1] += $x
			$R[2] += $c
		Case 4
			$R[0] += $x
			$R[2] += $c
		Case Else
			$R[0] += $c
			$R[2] += $x
	EndSwitch
	Return Round($R[2]*255) + 256 * Round($R[1]*255) + 65536 * Round($R[0]*255) + 4278190080
EndFunc

; #FUNCTION# ====================================================================================================================
; Author ........: Mars
; Modified.......: das ist peak AutoIt, hier wird nicht modifiziert
; Description....: Input: float RGB[3], Output: float HSL[3]
; ===============================================================================================================================
Func _ColorIA_RGB2HSL($i)
	Local $u = DllStructCreate('byte b;byte g;byte r;byte a'), $_ = DllStructCreate('int i', DllStructGetPtr($u))
	$_.i = $i
	Local $r = $u.r/255, $g = $u.g/255, $b = $u.b/255, $V = $r > $g ? $r > $b ? $r : $b : $g > $b ? $g : $b, $m = $r < $g ? $r < $b ? $r : $b : $g < $b ? $g : $b, $c = $V - $m, $L = ($V + $m) / 2, $T = [$V = $m ? 0.0 : ($V = $r ? ($g - $b) / $c + 6.0 * ($g < $b) : $V = $g ? 2.0 + ($b - $r) / $c : 4.0 + ($r - $g) / $c) / 6.0, $L = 0 Or $L = 1 ? 0 : $c / (1 - Abs(2 * $V - $c - 1)), $L]
	Return $T
EndFunc

; #FUNCTION# ====================================================================================================================
; Author ........: Mars
; Modified.......: das ist peak AutoIt, hier wird nicht modifiziert
; Description....: Input: float RGB[3], Output: float HSL[3]
; ===============================================================================================================================
Func _ColorAA_RGB2HSL($a)
	Local $V = $a[0] > $a[1] ? $a[0] > $a[2] ? $a[0] : $a[2] : $a[1] > $a[2] ? $a[1] : $a[2], $m = $a[0] < $a[1] ? $a[0] < $a[2] ? $a[0] : $a[2] : $a[1] < $a[2] ? $a[1] : $a[2], $c = $V - $m, $L = ($V + $m) / 2, $R = [$V = $m ? 0.0 : ($V = $a[0] ? ($a[1] - $a[2]) / $c + 6.0 * ($a[1] < $a[2]) : $V = $a[1] ? 2.0 + ($a[2] - $a[0]) / $c : 4.0 + ($a[0] - $a[1]) / $c) / 6.0, $L = 0 Or $L = 1 ? 0 : $c / (1 - Abs(2 * $V - $c - 1)), $L]
	Return $R
EndFunc