
#include-once
#include 'Header.au3'
#include "Geometry2.au3"




; Wofür braucht man diese Funktionen ?
; Werden ggf. entfernt...

Func A3D_GeometryGetPoints($aGeo)
	Local $aIndices[UBound($aGeo[0])][1]
	For $i = 0 To UBound($aGeo[0]) - 1 Step 1
		$aIndices[$i][0] = $i
	Next
	$aGeo[1] = $aIndices
	Return $aGeo
EndFunc   ;==>A3D_GeometryGetPoints

Func A3D_GeometryAdd(ByRef $aGeo)
	Local $aVertices = $aGeo[0], $aIndices = $aGeo[1], $iGeoStart = 0, $iGeoEnd = 0, $iLastIndex = UBound($aIndices) - 1, $aRet[3] = [UBound($aIndices, 2), 0, 0]
	$A3D_VERTEXARRAY_OFFSET = A3D_AddVertex($aVertices[0][0], $aVertices[0][1], $aVertices[0][2])
	For $i = 1 To UBound($aVertices) - 1 Step 1
		A3D_AddVertex($aVertices[$i][0], $aVertices[$i][1], $aVertices[$i][2])
	Next
	Switch $aRet[0]
		Case $A3D_TYPE_POINT
			$aRet[1] = A3D_AddPoint($aIndices[0][0])
			For $i = 1 To $iLastIndex - 1 Step 1
				A3D_AddPoint($aIndices[$i][0])
			Next
			$aRet[2] = A3D_AddPoint($aIndices[$iLastIndex][0])
		Case $A3D_TYPE_LINE
			$aRet[1] = A3D_AddLine($aIndices[0][0], $aIndices[0][1])
			For $i = 1 To $iLastIndex - 1 Step 1
				A3D_AddLine($aIndices[$i][0], $aIndices[$i][1])
			Next
			$aRet[2] = A3D_AddLine($aIndices[$iLastIndex][0], $aIndices[$iLastIndex][1])
		Case $A3D_TYPE_TRIANGLE
			$aRet[1] = A3D_AddTriangle($aIndices[0][0], $aIndices[0][1], $aIndices[0][2])
			For $i = 1 To $iLastIndex - 1 Step 1
				A3D_AddTriangle($aIndices[$i][0], $aIndices[$i][1], $aIndices[$i][2])
			Next
			$aRet[2] = A3D_AddTriangle($aIndices[$iLastIndex][0], $aIndices[$iLastIndex][1], $aIndices[$iLastIndex][2])
		Case $A3D_TYPE_QUAD
			$aRet[1] = A3D_AddQuad($aIndices[0][0], $aIndices[0][1], $aIndices[0][2], $aIndices[0][3])
			For $i = 1 To $iLastIndex - 1 Step 1
				A3D_AddQuad($aIndices[$i][0], $aIndices[$i][1], $aIndices[$i][2], $aIndices[$i][3])
			Next
			$aRet[2] = A3D_AddQuad($aIndices[$iLastIndex][0], $aIndices[$iLastIndex][1], $aIndices[$iLastIndex][2], $aIndices[$iLastIndex][3])
	EndSwitch
	Return $aRet
EndFunc   ;==>A3D_GeometryAdd

Func _getPointOnSphere()
	Local $x = Random(-1, 1), $y = Random(-1, 1), $z = Random(-1, 1), $s = Sqrt($x ^ 2 + $y ^ 2 + $z ^ 2)
	Local $a = [$x / $s, $y / $s, $z / $s]
	Return $a
EndFunc   ;==>_getPointOnSphere

Func A3D_GeometrySphereFromArray(ByRef $a)
	$A3D_VERTEXARRAY_OFFSET = A3D_AddVertex($a[0][0], $a[0][1], $a[0][2])
	For $i = 1 To UBound($a) - 2 Step 1
		A3D_AddVertex($a[$i][0], $a[$i][1], $a[$i][2])
	Next
	Local $VertexIndexEnd = A3D_AddVertex($a[UBound($a) - 1][0], $a[UBound($a) - 1][1], $a[UBound($a) - 1][2])
	Local $PointIndexStart = A3D_AddPoint(0)
	For $i = 1 To UBound($a) - 2 Step 1
		A3D_AddPoint($i)
	Next
	Local $PointIndexEnd = A3D_AddPoint(UBound($a) - 1)
	Local $aRet = [$PointIndexStart, $PointIndexEnd]
	Return $aRet
EndFunc   ;==>A3D_GeometrySphereFromArray

Func A3D_GeometrySpherePoints($x, $y, $z, $w, $h, $t, $n = 16)
	Local $a = _getPointOnSphere()
	$A3D_VERTEXARRAY_OFFSET = A3D_AddVertex($a[0], $a[1], $a[2])
	For $i = 2 To $n - 1 Step 1
		$a = _getPointOnSphere()
		A3D_AddVertex($a[0], $a[1], $a[2])
	Next
	$a = _getPointOnSphere()
	Local $VertexIndexEnd = A3D_AddVertex($a[0], $a[1], $a[2])
	For $i = $A3D_VERTEXARRAY_OFFSET To $VertexIndexEnd Step 1
		$A3D_VERTEXARRAY[$i * 3 + 0] = $A3D_VERTEXARRAY[$i * 3 + 0] * $w + $x
		$A3D_VERTEXARRAY[$i * 3 + 1] = $A3D_VERTEXARRAY[$i * 3 + 1] * $h + $y
		$A3D_VERTEXARRAY[$i * 3 + 2] = $A3D_VERTEXARRAY[$i * 3 + 2] * $t + $z
	Next
	Local $PointIndexStart = A3D_AddPoint(0)
	For $i = 2 To $n - 1 Step 1
		A3D_AddPoint($i - 1)
	Next
	Local $PointIndexEnd = A3D_AddPoint($n - 1)
	Local $aRet = [$PointIndexStart, $PointIndexEnd]
	Return $aRet
EndFunc   ;==>A3D_GeometrySpherePoints

Func A3D_AddGeometry_CubeQuads($x, $y, $z, $w, $h, $t)
	$A3D_VERTEXARRAY_OFFSET = A3D_AddVertex(0, 0, 0)
	A3D_AddVertex(0, 0, 1)
	A3D_AddVertex(1, 0, 1)
	A3D_AddVertex(1, 0, 0)
	A3D_AddVertex(0, 1, 1)
	A3D_AddVertex(1, 1, 1)
	A3D_AddVertex(1, 1, 0)
	Local $VertexIndexEnd = A3D_AddVertex(0, 1, 0)
	For $i = $A3D_VERTEXARRAY_OFFSET To $VertexIndexEnd Step 1
		$A3D_VERTEXARRAY[$i * 3 + 0] = $A3D_VERTEXARRAY[$i * 3 + 0] * $w + $x
		$A3D_VERTEXARRAY[$i * 3 + 1] = $A3D_VERTEXARRAY[$i * 3 + 1] * $h + $y
		$A3D_VERTEXARRAY[$i * 3 + 2] = $A3D_VERTEXARRAY[$i * 3 + 2] * $t + $z
	Next
	Local $QuadIndexStart = A3D_AddQuad(1, 0, 3, 2) ; richtig
	A3D_AddQuad(2, 3, 6, 5) ; ??
	A3D_AddQuad(0, 1, 4, 7) ; ??
	A3D_AddQuad(2, 5, 4, 1) ; ??
	A3D_AddQuad(6, 3, 0, 7) ; ??
	Local $QuadIndexEnd = A3D_AddQuad(4, 5, 6, 7) ; richtig
;~ 	_ArrayDisplay($A3D_QUADARRAY)
	Local $aRet = [$QuadIndexStart, $QuadIndexEnd]
	Return $aRet
EndFunc   ;==>A3D_AddGeometry_CubeQuads

Func A3D_AddGeometry_Cube($x, $y, $z, $w, $h, $t) ; Returns [VertexIndexStart, VertexIndexEnd, TriangleIndexStart, TriangleIndexEnd]
	$A3D_VERTEXARRAY_OFFSET = A3D_AddVertex(0, 0, 0)
	A3D_AddVertex(0, 0, 1)
	A3D_AddVertex(1, 0, 1)
	A3D_AddVertex(1, 0, 0)
	A3D_AddVertex(0, 1, 1)
	A3D_AddVertex(1, 1, 1)
	A3D_AddVertex(1, 1, 0)
	Local $VertexIndexEnd = A3D_AddVertex(0, 1, 0)
	For $i = $A3D_VERTEXARRAY_OFFSET To $VertexIndexEnd Step 1
		$A3D_VERTEXARRAY[$i * 3 + 0] = $A3D_VERTEXARRAY[$i * 3 + 0] * $w + $x
		$A3D_VERTEXARRAY[$i * 3 + 1] = $A3D_VERTEXARRAY[$i * 3 + 1] * $h + $y
		$A3D_VERTEXARRAY[$i * 3 + 2] = $A3D_VERTEXARRAY[$i * 3 + 2] * $t + $z
	Next
	Local $TriangleIndexStart = A3D_AddTriangle(0, 1, 4)
	A3D_AddTriangle(0, 4, 7)
	A3D_AddTriangle(1, 5, 4)
	A3D_AddTriangle(1, 2, 5)
	A3D_AddTriangle(2, 3, 6)
	A3D_AddTriangle(2, 6, 5)
	A3D_AddTriangle(0, 3, 2)
	A3D_AddTriangle(0, 2, 1)
	A3D_AddTriangle(0, 7, 3)
	A3D_AddTriangle(3, 7, 6)
	A3D_AddTriangle(4, 5, 7)
	Local $TriangleIndexEnd = A3D_AddTriangle(5, 6, 7)
	Local $aRet = [$TriangleIndexStart, $TriangleIndexEnd]
	Return $aRet
EndFunc   ;==>A3D_AddGeometry_Cube
