#include-once

Global Const $A3D_VERTEXARRAY_LIMIT   = 4096*5
Global Const $A3D_LINEARRAY_LIMIT     = 4096*5
Global Const $A3D_TRIANGLEARRAY_LIMIT = 4096*5
Global Const $A3D_QUADARRAY_LIMIT     = 4096*5
Global Const $A3D_POINTARRAY_LIMIT    = 4096*5
Global Const $A3D_MATRISTACK_LIMIT    = 1024*5

Global Const $A3D_DEGTORAD = ATan(1) / 45
Global Const $A3D_RADTODEG = 45 / ATan(1)
Global Const $A3D_EPSILON  = 1e-6 ; Vertices die näher zusammen liegen als das werden als "ein Vertex" interpretiert.



; Überarbeitungsbedarf
Global $A3D_FOV = $A3D_DEGTORAD * 70
Global $A3D_FOVRAD = 1 / Tan($A3D_FOV / 2) ; Factor
Global $A3D_WIDTH = 600  ; Das sollte variabel sein.... jaja.
Global $A3D_HEIGHT = Int($A3D_WIDTH / 1.3)
Global $A3D_ASPECT = $A3D_WIDTH / $A3D_HEIGHT
Global $A3D_FOVRADDIVASPECT = $A3D_FOVRAD / $A3D_ASPECT
Global $A3D_CLIPNEAR = 0.1
Global $A3D_CLIPFAR = 100
Global $A3D_CLIP = $A3D_CLIPNEAR / ($A3D_CLIPFAR - $A3D_CLIPNEAR) ; Normalized
Global $A3D_CLIPRANGE = $A3D_CLIPFAR - $A3D_CLIPNEAR

; Matrizen
Global Const $__A3D_MATRIX_IDENTITY = [[1, 0, 0, 0], [0, 1, 0, 0], [0, 0, 1, 0], [0, 0, 0, 1]]
Global $A3D_PROJECTIONMATRIX = __A3D_ProjectionMatrix()
Global $A3D_DRAW_MATRIX = $__A3D_MATRIX_IDENTITY ; (aktuell verwendete Matrix)

; Matrixstack
Global $A3D_MATRIXSTACK[$A3D_MATRISTACK_LIMIT] = [$__A3D_MATRIX_IDENTITY] ; enthält jeweils eine 4x4 Matrix (homogene Koordinaten)
Global $A3D_MATRIXSTACK_COUNT = 1 ; default Matrix (kann nicht gepoppt werden) ist die Einheitsmatrix.

; Camera (not implemented yet)
Global $A3D_CP[3] = [0, 0,  0] ; CameraPosition
Global $A3D_CN[3] = [0, 0, -1] ; CameraNormal
Global $A3D_LP[3] = [0, 0,  0] ; LightPosition
Global $A3D_LN[3] = [0, 0, -1] ; LightNormal

; Vertices (aktueller Frame)
;~ Global $A3D_DVA[$A3D_VERTEXARRAY_LIMIT * 3]
Global $A3D_DVA[$A3D_VERTEXARRAY_LIMIT][3] ; [0] = x, [1] = y, [2] = z
Global $A3D_DVAINDEX[$A3D_VERTEXARRAY_LIMIT]
Global $A3D_DVA_COUNT = 0
Global $A3D_DVA_OFFSET = 0

; Object Arrays
Global $A3D_DPA[$A3D_POINTARRAY_LIMIT]    [2] ; [0] = iVertex,                                                  [1] = aHSL -> A3D_DRAW_POINTARRAY
Global $A3D_DLA[$A3D_LINEARRAY_LIMIT]     [3] ; [0] = iVertex1, [1] = iVertex2,                                 [2] = aHSL -> A3D_DRAW_LINEARRAY
Global $A3D_DTA[$A3D_TRIANGLEARRAY_LIMIT] [4] ; [0] = iVertex1, [1] = iVertex2, [2] = iVertex3,                 [3] = aHSL -> A3D_DRAW_TRIANGLEARRAY
Global $A3D_DQA[$A3D_QUADARRAY_LIMIT]     [5] ; [0] = iVertex1, [1] = iVertex2, [2] = iVertex3, [3] = iVertex4, [4] = aHSL -> A3D_DRAW_QUADARRAY

Global $A3D_DPA_COUNT = 0
Global $A3D_DLA_COUNT = 0
Global $A3D_DTA_COUNT = 0
Global $A3D_DQA_COUNT = 0

Global $A3D_COLOR_DEFAULT_POINT    = [0.35, 0.5, 0.5]
Global $A3D_COLOR_DEFAULT_LINE     = [0.55, 0.5, 0.5]
Global $A3D_COLOR_DEFAULT_TRIANGLE = [0.75, 0.5, 0]
Global $A3D_COLOR_DEFAULT_QUAD     = [0.95, 0.5, 0]

; z-Buffer (aktueller Frame)
Global $A3D_DPZ[$A3D_POINTARRAY_LIMIT]    [2] ; [0] = ObjektIndex, [1] = z
Global $A3D_DLZ[$A3D_LINEARRAY_LIMIT]     [2] ; [0] = ObjektIndex, [1] = z
Global $A3D_DTZ[$A3D_TRIANGLEARRAY_LIMIT] [2] ; [0] = ObjektIndex, [1] = z
Global $A3D_DQZ[$A3D_QUADARRAY_LIMIT]     [2] ; [0] = ObjektIndex, [1] = z
; Ggf muss man hier optimieren, da 4x Quicksort und anschließend eine Art Mergesort verwendet wird.
; vorher alles in ein Array (oder insgesamt nur 1 Array + Objektdefinition) wäre besser.

Global $A3D_DPZ_COUNT = 0
Global $A3D_DLZ_COUNT = 0
Global $A3D_DTZ_COUNT = 0
Global $A3D_DQZ_COUNT = 0

Global $A3D_DPZ_INDEX = 0
Global $A3D_DLZ_INDEX = 0
Global $A3D_DTZ_INDEX = 0
Global $A3D_DQZ_INDEX = 0

; Baustelle -> Die Normals werden doof berechnet
; Quadnormals werden gar nicht berechnet (es werden einfach 3 Punkte vom Quad als Triangle verwendet)

; normal-Buffer (global) (points/lines haben keine Normalen)
; es ist noch nicht klar ob es schlau ist die zu berechnen, weil man sie ja ansich sowieso für jeden Frame neu transformieren muss...
Global $A3D_TRIANGLENORMALS[$A3D_TRIANGLEARRAY_LIMIT * 3]
Global $A3D_QUADNORMALS[$A3D_QUADARRAY_LIMIT * 3]

; normal-Buffer (aktueller Frame) (points/lines haben keine Normalen)
Global $A3D_DRAW_TRIANGLENORMALS[$A3D_TRIANGLEARRAY_LIMIT * 3]
Global $A3D_DRAW_QUADNORMALS[$A3D_QUADARRAY_LIMIT * 3]



Func __A3D_ProjectionMatrix()
	Local $_ = [[$A3D_FOVRADDIVASPECT, 0, 0, 0], [0, $A3D_FOVRAD, 0, 0], [0, 0, ($A3D_CLIPFAR + $A3D_CLIPNEAR) / ($A3D_CLIPFAR - $A3D_CLIPNEAR), (2 * $A3D_CLIPFAR * $A3D_CLIPNEAR) / ($A3D_CLIPFAR - $A3D_CLIPNEAR)], [0, 0, -1, 1]]
	Return $_
EndFunc