



Func MyColors(ByRef $aVertices, ByRef $aIndices, ByRef $aColors)

	Local $WATER = 0.7

	Local $RGB
	For $i = 0 To UBound($aColors) - 1 Step 1
		Local $P1 = [$aVertices[$aIndices[$i][0]][0], $aVertices[$aIndices[$i][0]][1], $aVertices[$aIndices[$i][0]][2]]
		Local $P2 = [$aVertices[$aIndices[$i][1]][0], $aVertices[$aIndices[$i][1]][1], $aVertices[$aIndices[$i][1]][2]]
		Local $P3 = [$aVertices[$aIndices[$i][2]][0], $aVertices[$aIndices[$i][2]][1], $aVertices[$aIndices[$i][2]][2]]
		Local $PM = [($P1[0] + $P2[0] + $P3[0])/3, ($P1[1] + $P2[1] + $P3[1])/3, ($P1[2] + $P2[2] + $P3[2])/3]
		Local $L = Sqrt($PM[0]^2+$PM[1]^2+$PM[2]^2)
;~ 		ConsoleWrite($L & @CRLF)
		If $L < $WATER Then
			$RGB = 0x748AE0
			If Len($P1) < $WATER Then Normalize($P1, $WATER)
			If Len($P2) < $WATER Then Normalize($P2, $WATER)
			If Len($P3) < $WATER Then Normalize($P3, $WATER)
			$aVertices[$aIndices[$i][0]][0] = $P1[0]
			$aVertices[$aIndices[$i][0]][1] = $P1[1]
			$aVertices[$aIndices[$i][0]][2] = $P1[2]
			$aVertices[$aIndices[$i][1]][0] = $P2[0]
			$aVertices[$aIndices[$i][1]][1] = $P2[1]
			$aVertices[$aIndices[$i][1]][2] = $P2[2]
			$aVertices[$aIndices[$i][2]][0] = $P3[0]
			$aVertices[$aIndices[$i][2]][1] = $P3[1]
			$aVertices[$aIndices[$i][2]][2] = $P3[2]
		ElseIf $L < 0.8 Then
			$RGB = 0x61A45E
		ElseIf $L < 0.85 Then
;~ 			$RGB = 0x94580C
			$RGB = 0xF1F1F4
		Else
			$RGB = 0xF1F1F4
		EndIf
		$aColors[$i] = _ColorIA_RGB2HSL($RGB)
	Next
EndFunc



Func _GeometrySmooth(ByRef $aGeo, $nAmount) ; vorsicht. Das smootht kein stück sondern haut alles kaputt.
	Local $aVertices = $aGeo[0], $u = UBound($aVertices)

	For $i = 0 To $nAmount - 1 Step 1

	Local $R = [Random(0, $u-1, 1), Random(0, $u-1, 1), Random(0, $u-1, 1)]
	Local $P1 = [$aVertices[$R[0]][0], $aVertices[$R[0]][1], $aVertices[$R[0]][2]]
	Local $P2 = [$aVertices[$R[1]][0], $aVertices[$R[1]][1], $aVertices[$R[1]][2]]
	Local $P3 = [$aVertices[$R[2]][0], $aVertices[$R[2]][1], $aVertices[$R[2]][2]]

	Local $L1 = Dist($P1, $P2)
	Local $L2 = Dist($P1, $P3)
	Local $L3 = Dist($P2, $P3)

	Switch _3MaxI($L1, $L2, $L3)
		Case 0
			Local $V = [$P1[0] - $P2[0], $P1[1] - $P2[1], $P1[2] - $P2[2]]
			Normalize($V, 0.005)
			$P1 = Sub($P1, $V)
			$P2 = Add($P2, $V)
			$aVertices[$R[0]][0] = $P1[0]
			$aVertices[$R[0]][1] = $P1[1]
			$aVertices[$R[0]][2] = $P1[2]
			$aVertices[$R[1]][0] = $P2[0]
			$aVertices[$R[1]][1] = $P2[1]
			$aVertices[$R[1]][2] = $P2[2]
		Case 1
			Local $V = [$P1[0] - $P3[0], $P1[1] - $P3[1], $P1[2] - $P3[2]]
			Normalize($V, 0.005)
			$P1 = Sub($P1, $V)
			$P3 = Add($P3, $V)
			$aVertices[$R[0]][0] = $P1[0]
			$aVertices[$R[0]][1] = $P1[1]
			$aVertices[$R[0]][2] = $P1[2]
			$aVertices[$R[2]][0] = $P3[0]
			$aVertices[$R[2]][1] = $P3[1]
			$aVertices[$R[2]][2] = $P3[2]
		Case 2
			Local $V = [$P2[0] - $P3[0], $P2[1] - $P3[1], $P2[2] - $P3[2]]
			Normalize($V, 0.005)
			$P2 = Sub($P2, $V)
			$P3 = Add($P3, $V)
			$aVertices[$R[1]][0] = $P2[0]
			$aVertices[$R[1]][1] = $P2[1]
			$aVertices[$R[1]][2] = $P2[2]
			$aVertices[$R[2]][0] = $P3[0]
			$aVertices[$R[2]][1] = $P3[1]
			$aVertices[$R[2]][2] = $P3[2]
	EndSwitch

	Next

	$aGeo[0] = $aVertices

EndFunc

Func Add(ByRef $a, ByRef $b)
	Local $c = [$a[0] + $b[0], $a[1] + $b[1], $a[2] + $b[2]]
	Return $c
EndFunc

Func Sub(ByRef $a, ByRef $b)
	Local $c = [$a[0] - $b[0], $a[1] - $b[1], $a[2] - $b[2]]
	Return $c
EndFunc

Func Normalize(ByRef $a, $n = 1)
	Local $l = Sqrt($a[0]*$a[0] + $a[1]*$a[1] + $a[2]*$a[2])
	If $l > 1e-7 Then
		$a[0] /= $l / $n
		$a[1] /= $l / $n
		$a[2] /= $l / $n
	EndIf
EndFunc

Func Len(ByRef $a)
	Return Sqrt($a[0]*$a[0] + $a[1]*$a[1] + $a[2]*$a[2])
EndFunc

Func Dist(ByRef $a, ByRef $b)
	Return Sqrt(($a[0]-$b[0])^2 + ($a[1]-$b[1])^2 + ($a[2]-$b[2])^2)
EndFunc




Func A3D_AddPoint($v)
	$A3D_POINTARRAY[$A3D_POINTARRAY_COUNT] = $v + $A3D_VERTEXARRAY_OFFSET
	$A3D_POINTARRAY_COUNT += 1
	Return $A3D_POINTARRAY_COUNT - 1
EndFunc   ;==>A3D_AddPoint

Func A3D_AddLine($v1, $v2)
	$A3D_LINEARRAY[$A3D_LINEARRAY_COUNT * 2 + 0] = $v1 + $A3D_LINEARRAY_OFFSET
	$A3D_LINEARRAY[$A3D_LINEARRAY_COUNT * 2 + 1] = $v2 + $A3D_LINEARRAY_OFFSET
	$A3D_LINEARRAY_COUNT += 1
	Return $A3D_LINEARRAY_COUNT - 1
EndFunc   ;==>A3D_AddLine

Func A3D_AddTriangle($v1, $v2, $v3)
	$A3D_TRIANGLEARRAY[$A3D_TRIANGLEARRAY_COUNT * 3 + 0] = $v1 + $A3D_VERTEXARRAY_OFFSET
	$A3D_TRIANGLEARRAY[$A3D_TRIANGLEARRAY_COUNT * 3 + 1] = $v2 + $A3D_VERTEXARRAY_OFFSET
	$A3D_TRIANGLEARRAY[$A3D_TRIANGLEARRAY_COUNT * 3 + 2] = $v3 + $A3D_VERTEXARRAY_OFFSET
	$A3D_TRIANGLEARRAY_COUNT += 1
	Return $A3D_TRIANGLEARRAY_COUNT - 1
EndFunc   ;==>A3D_AddTriangle

Func A3D_AddQuad($v1, $v2, $v3, $v4) ; Nur nehmen, wenn die 4 Punkte in einer Ebene liegen, sonst lieber Triangles
	$A3D_QUADARRAY[$A3D_QUADARRAY_COUNT * 4 + 0] = $v1 + $A3D_VERTEXARRAY_OFFSET
	$A3D_QUADARRAY[$A3D_QUADARRAY_COUNT * 4 + 1] = $v2 + $A3D_VERTEXARRAY_OFFSET
	$A3D_QUADARRAY[$A3D_QUADARRAY_COUNT * 4 + 2] = $v3 + $A3D_VERTEXARRAY_OFFSET
	$A3D_QUADARRAY[$A3D_QUADARRAY_COUNT * 4 + 3] = $v4 + $A3D_VERTEXARRAY_OFFSET
	$A3D_QUADARRAY_COUNT += 1
	Return $A3D_QUADARRAY_COUNT - 1
EndFunc   ;==>A3D_AddQuad

Func A3D_AddVertex($x, $y, $z)
	$A3D_VERTEXARRAY[$A3D_VERTEXARRAY_COUNT * 3 + 0] = $x
	$A3D_VERTEXARRAY[$A3D_VERTEXARRAY_COUNT * 3 + 1] = $y
	$A3D_VERTEXARRAY[$A3D_VERTEXARRAY_COUNT * 3 + 2] = $z
	$A3D_VERTEXARRAY_COUNT += 1
	Return $A3D_VERTEXARRAY_COUNT - 1
EndFunc   ;==>A3D_AddVertex

Func A3D_TriangleNormal($i)
	Local $aTri = [$A3D_TRIANGLEARRAY[$i * 3 + 0], $A3D_TRIANGLEARRAY[$i * 3 + 1], $A3D_TRIANGLEARRAY[$i * 3 + 2]]
	Local $aVec3f_1 = [$A3D_VERTEXARRAY[$aTri[0] * 3 + 0], $A3D_VERTEXARRAY[$aTri[0] * 3 + 1], $A3D_VERTEXARRAY[$aTri[0] * 3 + 2]]
	Local $aVec3f_2 = [$A3D_VERTEXARRAY[$aTri[1] * 3 + 0], $A3D_VERTEXARRAY[$aTri[1] * 3 + 1], $A3D_VERTEXARRAY[$aTri[1] * 3 + 2]]
	Local $aVec3f_3 = [$A3D_VERTEXARRAY[$aTri[2] * 3 + 0], $A3D_VERTEXARRAY[$aTri[2] * 3 + 1], $A3D_VERTEXARRAY[$aTri[2] * 3 + 2]]
	Return Vec3fCrossTriangle($aVec3f_1, $aVec3f_2, $aVec3f_3)
EndFunc   ;==>A3D_TriangleNormal

Func A3D_QuadNormal($i) ; TODO -> Aktuell dieselbe Methode wie für Triangles.
	Local $aTri = [$A3D_QUADARRAY[$i * 3 + 0], $A3D_QUADARRAY[$i * 3 + 1], $A3D_QUADARRAY[$i * 3 + 2]]
	Local $aVec3f_1 = [$A3D_VERTEXARRAY[$aTri[0] * 3 + 0], $A3D_VERTEXARRAY[$aTri[0] * 3 + 1], $A3D_VERTEXARRAY[$aTri[0] * 3 + 2]]
	Local $aVec3f_2 = [$A3D_VERTEXARRAY[$aTri[1] * 3 + 0], $A3D_VERTEXARRAY[$aTri[1] * 3 + 1], $A3D_VERTEXARRAY[$aTri[1] * 3 + 2]]
	Local $aVec3f_3 = [$A3D_VERTEXARRAY[$aTri[2] * 3 + 0], $A3D_VERTEXARRAY[$aTri[2] * 3 + 1], $A3D_VERTEXARRAY[$aTri[2] * 3 + 2]]
	Return Vec3fCrossTriangle($aVec3f_1, $aVec3f_2, $aVec3f_3)
EndFunc   ;==>A3D_QuadNormal

Func Vec3fRotXRef(ByRef $aVec3f, $alpha)
	Local $y = $aVec3f[1]
	$aVec3f[1] = $y * Cos($alpha) - $aVec3f[2] * Sin($alpha)
	$aVec3f[2] = $y * Sin($alpha) + $aVec3f[2] * Cos($alpha)
EndFunc   ;==>Vec3fRotXRef

Func Vec3fRotX($aVec3f, $alpha)
	Local $y = $aVec3f[1]
	$aVec3f[1] = $y * Cos($alpha) - $aVec3f[2] * Sin($alpha)
	$aVec3f[2] = $y * Sin($alpha) + $aVec3f[2] * Cos($alpha)
	Return $aVec3f
EndFunc   ;==>Vec3fRotX


Func RotXYZ(ByRef $aVec3f, $alpha, $beta, $gamma)
	Local $t = $aVec3f[1]
	$aVec3f[1] = $t * Cos($alpha) - $aVec3f[2] * Sin($alpha)
	$aVec3f[2] = $t * Sin($alpha) + $aVec3f[2] * Cos($alpha)
	$t = $aVec3f[0]
	$aVec3f[0] = $t * Cos($beta) - $aVec3f[2] * Sin($beta)
	$aVec3f[2] = $t * Sin($beta) + $aVec3f[2] * Cos($beta)
	$t = $aVec3f[0]
	$aVec3f[0] = $t * Cos($gamma) - $aVec3f[1] * Sin($gamma)
	$aVec3f[1] = $t * Sin($gamma) + $aVec3f[1] * Cos($gamma)
EndFunc   ;==>RotXYZ

Func RotX(ByRef $aVec3f, $alpha)
	Local $y = $aVec3f[1]
	$aVec3f[1] = $y * Cos($alpha) - $aVec3f[2] * Sin($alpha)
	$aVec3f[2] = $y * Sin($alpha) + $aVec3f[2] * Cos($alpha)
EndFunc   ;==>RotX

Func RotY(ByRef $aVec3f, $alpha)
	Local $x = $aVec3f[0]
	$aVec3f[0] = $x * Cos($alpha) - $aVec3f[2] * Sin($alpha)
	$aVec3f[2] = $x * Sin($alpha) + $aVec3f[2] * Cos($alpha)
EndFunc   ;==>RotY

Func RotZ(ByRef $aVec3f, $alpha)
	Local $x = $aVec3f[0]
	$aVec3f[0] = $x * Cos($alpha) - $aVec3f[1] * Sin($alpha)
	$aVec3f[1] = $x * Sin($alpha) + $aVec3f[1] * Cos($alpha)
EndFunc   ;==>RotZ

Func TransX(ByRef $aVec3f, $dx)
	$aVec3f[0] += $dx
EndFunc   ;==>TransX

Func TransY(ByRef $aVec3f, $dy)
	$aVec3f[1] += $dy
EndFunc   ;==>TransY

Func TransZ(ByRef $aVec3f, $dz)
	$aVec3f[2] += $dz
EndFunc   ;==>TransZ

Func Vec3fToScreenspaceRef(ByRef $aVec3f)
	$aVec3f[0] = ($aVec3f[0] + 1) / 2 * $A3D_WIDTH
	$aVec3f[1] = ($aVec3f[1] + 1) / 2 * $A3D_HEIGHT
EndFunc   ;==>Vec3fToScreenspaceRef

Func Vec3fToScreenspace($aVec3f)
	$aVec3f[0] = ($aVec3f[0] + 1) / 2 * $A3D_WIDTH
	$aVec3f[1] = ($aVec3f[1] + 1) / 2 * $A3D_HEIGHT
	Return $aVec3f
EndFunc   ;==>Vec3fToScreenspace

Func Vec3fProjectRef(ByRef $aVec3f)
	$aVec3f[0] *= $A3D_FOVRADDIVASPECT / $aVec3f[2]
	$aVec3f[1] *= $A3D_FOVRAD / $aVec3f[2]
	$aVec3f[2] = ($aVec3f[2] - $A3D_CLIPNEAR) * $A3D_CLIPFAR / ($A3D_CLIPFAR - $A3D_CLIPNEAR)
EndFunc   ;==>Vec3fProjectRef

Func Proj2()
	Local $_ = [ _
			[$A3D_WIDTH / 2, 0, 0, $A3D_WIDTH / 2], _
			[0, $A3D_HEIGHT / 2, 0, $A3D_HEIGHT / 2], _
			[0, 0, 1, 0], _
			[0, 0, 0, 1]]
	Return $_
EndFunc   ;==>Proj2

Func Vec3fProject($aVec3f)
	$aVec3f[0] *= $A3D_FOVRADDIVASPECT / $aVec3f[2]
	$aVec3f[1] *= $A3D_FOVRAD / $aVec3f[2]
	$aVec3f[2] = ($aVec3f[2] - $A3D_CLIPNEAR) * $A3D_CLIPFAR / ($A3D_CLIPFAR - $A3D_CLIPNEAR)
	Return $aVec3f
EndFunc   ;==>Vec3fProject

Func _GDIPlus_GraphicsDrawTriangle($hBUF, ByRef $v1, ByRef $v2, ByRef $v3, ByRef $hPEN)
	Local $aPoints[4][2]
	$aPoints[0][0] = 3
	$aPoints[1][0] = $v1[0]
	$aPoints[1][1] = $v1[1]
	$aPoints[2][0] = $v2[0]
	$aPoints[2][1] = $v2[1]
	$aPoints[3][0] = $v3[0]
	$aPoints[3][1] = $v3[1]
	_GDIPlus_GraphicsDrawPolygon($hBUF, $aPoints, $hPEN)
EndFunc   ;==>_GDIPlus_GraphicsDrawTriangle

Func _GDIPlus_GraphicsFillTriangle($hBUF, ByRef $v1, ByRef $v2, ByRef $v3, ByRef $hBRU)
	Local $aPoints[4][2]
	$aPoints[0][0] = 3
	$aPoints[1][0] = $v1[0]
	$aPoints[1][1] = $v1[1]
	$aPoints[2][0] = $v2[0]
	$aPoints[2][1] = $v2[1]
	$aPoints[3][0] = $v3[0]
	$aPoints[3][1] = $v3[1]
	_GDIPlus_GraphicsFillPolygon($hBUF, $aPoints, $hBRU)
EndFunc   ;==>_GDIPlus_GraphicsFillTriangle

Func _GDIPlus_GraphicsFillQuad($hBUF, ByRef $v1, ByRef $v2, ByRef $v3, ByRef $v4, ByRef $hBRU)
	Local $aPoints[5][2]
	$aPoints[0][0] = 4
	$aPoints[1][0] = $v1[0]
	$aPoints[1][1] = $v1[1]
	$aPoints[2][0] = $v2[0]
	$aPoints[2][1] = $v2[1]
	$aPoints[3][0] = $v3[0]
	$aPoints[3][1] = $v3[1]
	$aPoints[4][0] = $v4[0]
	$aPoints[4][1] = $v4[1]
	_GDIPlus_GraphicsFillPolygon($hBUF, $aPoints, $hBRU)
EndFunc   ;==>_GDIPlus_GraphicsFillQuad

Func _GDIPlus_GraphicsDrawQuad($hBUF, ByRef $v1, ByRef $v2, ByRef $v3, ByRef $v4, ByRef $hPEN)
	Local $aPoints[5][2]
	$aPoints[0][0] = 4
	$aPoints[1][0] = $v1[0]
	$aPoints[1][1] = $v1[1]
	$aPoints[2][0] = $v2[0]
	$aPoints[2][1] = $v2[1]
	$aPoints[3][0] = $v3[0]
	$aPoints[3][1] = $v3[1]
	$aPoints[4][0] = $v4[0]
	$aPoints[4][1] = $v4[1]
	_GDIPlus_GraphicsDrawPolygon($hBUF, $aPoints, $hPEN)
EndFunc   ;==>_GDIPlus_GraphicsDrawQuad


Func __A3D_MatrixMultiplyV(ByRef $A, ByRef $v)
	Local $d = $A[3][0] * $v[0] + $A[3][1] * $v[1] + $A[3][2] * $v[2] + $A[3][3]
	Local $_ = [ _
			($A[0][0] * $v[0] + $A[0][1] * $v[1] + $A[0][2] * $v[2] + $A[0][3])/$d, _
			($A[1][0] * $v[0] + $A[1][1] * $v[1] + $A[1][2] * $v[2] + $A[1][3])/$d, _
			($A[2][0] * $v[0] + $A[2][1] * $v[1] + $A[2][2] * $v[2] + $A[2][3])/$d]
	Return $_
EndFunc   ;==>__A3D_MatrixMultiplyV

Func A3D_DrawPoint($i)
	Local $P = $A3D_POINTARRAY[$i]
;~ 	ConsoleWrite('DrawPoint(' & $i & '): [' & $P & ']:')
	If $A3D_DRAW_VERTEXARRAYINDEX[$P] = Null Then
;~ 		ConsoleWrite('[NEW]: AtVtxArray[' & $A3D_DRAW_VERTEXARRAY_COUNT * 3 + 0 & ', ' &$A3D_DRAW_VERTEXARRAY_COUNT * 3 + 1 & ', ' & $A3D_DRAW_VERTEXARRAY_COUNT * 3 + 2 & ']')
		Local $aVec3f = [$A3D_VERTEXARRAY[$P * 3 + 0], $A3D_VERTEXARRAY[$P * 3 + 1], $A3D_VERTEXARRAY[$P * 3 + 2]]

;~ 		$xFunc($aVec3f)
		Vec3fProjectRef($aVec3f)
		$A3D_DRAW_VERTEXARRAY[$A3D_DRAW_VERTEXARRAY_COUNT * 3 + 0] = $aVec3f[0]
		$A3D_DRAW_VERTEXARRAY[$A3D_DRAW_VERTEXARRAY_COUNT * 3 + 1] = $aVec3f[1]
		$A3D_DRAW_VERTEXARRAY[$A3D_DRAW_VERTEXARRAY_COUNT * 3 + 2] = $aVec3f[2]

		$A3D_DRAW_POINTARRAY[$A3D_DRAW_POINTARRAY_COUNT] = $A3D_DRAW_VERTEXARRAY_COUNT
		$A3D_DRAW_VERTEXARRAYINDEX[$P] = $A3D_DRAW_VERTEXARRAY_COUNT
		$A3D_DRAW_VERTEXARRAY_COUNT += 1


		$A3D_DRAW_VERTEXARRAY_INDEXLIST[$A3D_DRAW_VERTEXARRAY_INDEXLIST_COUNT] = $P
		$A3D_DRAW_VERTEXARRAY_INDEXLIST_COUNT += 1

	Else
;~ 		ConsoleWrite('[REUSE]: ')
		$A3D_DRAW_POINTARRAY[$A3D_DRAW_POINTARRAY_COUNT] = $A3D_DRAW_VERTEXARRAYINDEX[$P]
	EndIf
;~ 	ConsoleWrite(@CRLF)
	$A3D_DRAW_POINTARRAY_COUNT += 1
EndFunc   ;==>A3D_DrawPoint


Func A3D_MatrixScale($sx, $sy, $sz)
	Local $_ = [ _
			[$A3D_DRAW_MATRIX[0][0] * $sx, $A3D_DRAW_MATRIX[0][1] * $sy, $A3D_DRAW_MATRIX[0][2] * $sz, $A3D_DRAW_MATRIX[0][3]], _
			[$A3D_DRAW_MATRIX[1][0] * $sx, $A3D_DRAW_MATRIX[1][1] * $sy, $A3D_DRAW_MATRIX[1][2] * $sz, $A3D_DRAW_MATRIX[1][3]], _
			[$A3D_DRAW_MATRIX[2][0] * $sx, $A3D_DRAW_MATRIX[2][1] * $sy, $A3D_DRAW_MATRIX[2][2] * $sz, $A3D_DRAW_MATRIX[2][3]], _
			[$A3D_DRAW_MATRIX[3][0] * $sx, $A3D_DRAW_MATRIX[3][1] * $sy, $A3D_DRAW_MATRIX[3][2] * $sz, $A3D_DRAW_MATRIX[3][3]]]
	$A3D_DRAW_MATRIX = $_
EndFunc   ;==>A3D_MatrixScale

Func A3D_MatrixMultiply(ByRef $A)
	$A3D_DRAW_MATRIX = __A3D_MatrixMultiply($A3D_DRAW_MATRIX, $A)
EndFunc   ;==>A3D_MatrixMultiply



Func A3D_DrawTriangle($i)
	Local $aTri = [$A3D_TRIANGLEARRAY[$i * 3 + 0], $A3D_TRIANGLEARRAY[$i * 3 + 1], $A3D_TRIANGLEARRAY[$i * 3 + 2]]
;~ 	ConsoleWrite('DrawTriangle(' & $i & '): [' & $aTri[0] & ', ' & $aTri[1] & ', ' & $aTri[2] & ']:')
	For $v = 0 To 2 Step 1
;~ 		ConsoleWrite('V(' & $V & ')')
		If $A3D_DRAW_VERTEXARRAYINDEX[$aTri[$v]] = Null Then
;~ 			ConsoleWrite('[NEW]: ')
			Local $aVec3f = [$A3D_VERTEXARRAY[$aTri[$v] * 3 + 0], $A3D_VERTEXARRAY[$aTri[$v] * 3 + 1], $A3D_VERTEXARRAY[$aTri[$v] * 3 + 2]]
			$aVec3f = __A3D_MatrixMultiplyV($A3D_DRAW_MATRIX, $aVec3f)

;~ 			$xFunc($aVec3f)





			Vec3fProjectRef($aVec3f)
			$A3D_DRAW_VERTEXARRAY[$A3D_DRAW_VERTEXARRAY_COUNT * 3 + 0] = $aVec3f[0]
			$A3D_DRAW_VERTEXARRAY[$A3D_DRAW_VERTEXARRAY_COUNT * 3 + 1] = $aVec3f[1]
			$A3D_DRAW_VERTEXARRAY[$A3D_DRAW_VERTEXARRAY_COUNT * 3 + 2] = $aVec3f[2]

			$A3D_DRAW_TRIANGLEARRAY[$A3D_DRAW_TRIANGLEARRAY_COUNT * 3 + $v] = $A3D_DRAW_VERTEXARRAY_COUNT
			$A3D_DRAW_VERTEXARRAYINDEX[$aTri[$v]] = $A3D_DRAW_VERTEXARRAY_COUNT
			$A3D_DRAW_VERTEXARRAY_COUNT += 1

			$A3D_DRAW_VERTEXARRAY_INDEXLIST[$A3D_DRAW_VERTEXARRAY_INDEXLIST_COUNT] = $aTri[$v]
			$A3D_DRAW_VERTEXARRAY_INDEXLIST_COUNT += 1
		Else

			; Wenn position unterschiedlich -> Offset anlegen und bis zum Ende der Geometry beibehalten.




;~ 			ConsoleWrite('[REUSE]: ')
			$A3D_DRAW_TRIANGLEARRAY[$A3D_DRAW_TRIANGLEARRAY_COUNT * 3 + $v] = $A3D_DRAW_VERTEXARRAYINDEX[$aTri[$v]]
		EndIf
	Next
	$A3D_DRAW_TRIANGLEARRAY_COUNT += 1
;~ 	ConsoleWrite(@CRLF)
EndFunc   ;==>A3D_DrawTriangle



Func A3D_DrawQuad($i)
	Local $aQuad = [$A3D_QUADARRAY[$i * 4 + 0], $A3D_QUADARRAY[$i * 4 + 1], $A3D_QUADARRAY[$i * 4 + 2], $A3D_QUADARRAY[$i * 4 + 3]]
	For $v = 0 To 3 Step 1
		If $A3D_DRAW_VERTEXARRAYINDEX[$aQuad[$v]] = Null Then
			Local $aVec3f = [$A3D_VERTEXARRAY[$aQuad[$v] * 3 + 0], $A3D_VERTEXARRAY[$aQuad[$v] * 3 + 1], $A3D_VERTEXARRAY[$aQuad[$v] * 3 + 2]]
;~ 			$xFunc($aVec3f)
			Vec3fProjectRef($aVec3f)
			$A3D_DRAW_VERTEXARRAY[$A3D_DRAW_VERTEXARRAY_COUNT * 3 + 0] = $aVec3f[0]
			$A3D_DRAW_VERTEXARRAY[$A3D_DRAW_VERTEXARRAY_COUNT * 3 + 1] = $aVec3f[1]
			$A3D_DRAW_VERTEXARRAY[$A3D_DRAW_VERTEXARRAY_COUNT * 3 + 2] = $aVec3f[2]
			$A3D_DRAW_QUADARRAY[$A3D_DRAW_QUADARRAY_COUNT * 4 + $v] = $A3D_DRAW_VERTEXARRAY_COUNT
			$A3D_DRAW_VERTEXARRAYINDEX[$aQuad[$v]] = $A3D_DRAW_VERTEXARRAY_COUNT
			$A3D_DRAW_VERTEXARRAY_COUNT += 1

			$A3D_DRAW_VERTEXARRAY_INDEXLIST[$A3D_DRAW_VERTEXARRAY_INDEXLIST_COUNT] = $aQuad[$v]
			$A3D_DRAW_VERTEXARRAY_INDEXLIST_COUNT += 1

		Else
			$A3D_DRAW_QUADARRAY[$A3D_DRAW_QUADARRAY_COUNT * 4 + $v] = $A3D_DRAW_VERTEXARRAYINDEX[$aQuad[$v]]
		EndIf
	Next
	Local $aQuadNormal = [$A3D_QUADNORMALS[$i * 3 + 0], $A3D_QUADNORMALS[$i * 3 + 1], $A3D_QUADNORMALS[$i * 3 + 2]]
	$A3D_DRAW_QUADARRAY_COUNT += 1
EndFunc   ;==>A3D_DrawQuad



Func A3D_DrawQuadGeometry(ByRef $aGeo)
	For $i = $aGeo[0] To $aGeo[1] Step 1
		A3D_DrawQuad($i)
	Next
EndFunc   ;==>A3D_DrawQuadGeometry

Func A3D_DrawTriangleGeometry(ByRef $aGeo)
	For $i = $aGeo[0] To $aGeo[1] Step 1
		A3D_DrawTriangle($i)
	Next
EndFunc   ;==>A3D_DrawTriangleGeometry

Func A3D_DrawPointGeometry(ByRef $aGeo)
	For $i = $aGeo[0] To $aGeo[1] Step 1
		A3D_DrawPoint($i)
	Next
EndFunc   ;==>A3D_DrawPointGeometry

Func A3D_DrawGeometryID(ByRef $aGeoID)
	Switch $aGeoID[0]
		Case $A3D_TYPE_POINT
			For $i = $aGeoID[1] To $aGeoID[2] Step 1
				A3D_DrawPoint($i)
			Next
		Case $A3D_TYPE_LINE

		Case $A3D_TYPE_TRIANGLE
			For $i = $aGeoID[1] To $aGeoID[2] Step 1
				A3D_DrawTriangle($i)
			Next
		Case $A3D_TYPE_QUAD
			For $i = $aGeoID[1] To $aGeoID[2] Step 1
				A3D_DrawQuad($i)
			Next
	EndSwitch
EndFunc   ;==>A3D_DrawGeometryID
