
; Das ist nur ein Test :)

#include 'A3D.au3'

Opt('GuiOnEventMode', 1)

Global $bExit = False
Func Xit()
	$bExit = True
EndFunc

If @ScriptName = 'Test.au3' Then
	A3D_Example1()
EndIf

Func A3D_Example1()

	A3D_Init()

	Local $aGeoTetPoint = _GeometryTetrahedron($GEO_TYPE_POINT)
	Local $aGeoTetLine = _GeometryTetrahedron($GEO_TYPE_LINE)
	Local $aGeoTetTri = _GeometryTetrahedron($GEO_TYPE_TRIANGLE)

	Local $aGeoIcoPoint = _GeometryIcosahedron($GEO_TYPE_POINT)
	Local $aGeoIcoLine = _GeometryIcosahedron($GEO_TYPE_LINE)
	Local $aGeoIcoTri = _GeometryIcosahedron($GEO_TYPE_TRIANGLE)

	Local $aGeoCubePoint = _GeometryCube($GEO_TYPE_POINT)
	Local $aGeoCubeLine = _GeometryCube($GEO_TYPE_LINE)
	Local $aGeoCubeTri = _GeometryCube($GEO_TYPE_TRIANGLE)
	Local $aGeoCubeQuad = _GeometryCube($GEO_TYPE_QUAD)

	_GeometryScale($aGeoTetLine, 1.1, 1.1, 1.1) ; 1.01 reicht damit es keine Z-Buffer Probleme gibt, aber 1.1 sieht cooler aus.
	_GeometryScale($aGeoTetPoint, 1.1, 1.1, 1.1)
	_GeometrySubdiv($aGeoIcoTri)
	_GeometrySubdiv($aGeoIcoTri)
	_GeometryProjectOnSphere($aGeoIcoTri)


	; Da finde ich noch ne bessere Methode
	; Aktuell ist per Default ein leeres Array als Farbarray drin.
	; in [2] kann man das überschreiben.
	Local $aColors[UBound($aGeoIcoTri[1])], $aHSL = [0, 0.4, 0]
	For $i = 0 To UBound($aColors) - 1 Step 1
		$aHSL[0] = Random(0, 1) ; Random Hue, S = 0.4 (pastellfarben), L wird intern berechnet und hat aktuell keine Wirkung.
		$aColors[$i] = $aHSL
	Next
	$aGeoIcoTri[2] = $aColors

	_GDIPlus_Startup()
	Local $hGUI = GUICreate('', $A3D_WIDTH, $A3D_HEIGHT)
	Local $hGFX = _GDIPlus_GraphicsCreateFromHWND($hGUI)
	Local $hBMP = _GDIPlus_BitmapCreateFromGraphics($A3D_WIDTH, $A3D_HEIGHT, $hGFX)
	Local $hBUF = _GDIPlus_ImageGetGraphicsContext($hBMP)
	_GDIPlus_GraphicsSetSmoothingMode($hBUF, 2)
	GUISetState()

	GUISetOnEvent(-3, Xit)

	Local $iGlobalTimer = TimerInit(), $iGlobalTime
	Local $iFpsTimer = TimerInit()
	Local $iFPS = 0

	A3D_MatrixTranslate(0, 0, 5)

	While Not $bExit
		_GDIPlus_GraphicsClear($hBUF)
		$iGlobalTime = TimerDiff($iGlobalTimer)

		A3D_BeginScene()

		; Tetrahedron Point, Line, Triangle
		A3D_MatrixPush()
		A3D_MatrixTranslate(-2.1, 0, 0)
		A3D_MatrixRotate(Sin($iGlobalTime / 3000/1.234), Sin($iGlobalTime / 3000/1.234), Sin($iGlobalTime / 3000/1.234))
		A3D_GeometryDraw($aGeoTetTri)
		A3D_MatrixPop()

		A3D_MatrixPush()
		A3D_MatrixTranslate(-2.1, 0, 0)
		A3D_MatrixRotate(Sin($iGlobalTime / 3000/1.234), Sin($iGlobalTime / 3000/1.234), Sin($iGlobalTime / 3000/1.234))
		A3D_GeometryDraw($aGeoTetPoint)
		A3D_GeometryDraw($aGeoTetLine)
		A3D_MatrixPop()

		; Icosahedron Point, Line, Triangle
		A3D_MatrixPush()
		A3D_MatrixTranslate(0, -1, 0)
		A3D_MatrixRotate(Sin($iGlobalTime / 3000/2.234), Sin($iGlobalTime / 3000/0.987), Sin($iGlobalTime / 3000/1.634))
		A3D_GeometryDraw($aGeoIcoTri)
		A3D_MatrixPop()

		A3D_MatrixPush()
		A3D_MatrixTranslate(0, 1, 0)
		A3D_MatrixRotate(Sin($iGlobalTime / 3000/2.234), Sin($iGlobalTime / 3000/0.987), Sin($iGlobalTime / 3000/1.634))
		A3D_GeometryDraw($aGeoIcoPoint)
		A3D_GeometryDraw($aGeoIcoLine)
		A3D_MatrixPop()

		; Cube Point, Line, Triangle, Quad
		A3D_MatrixPush()
		A3D_MatrixTranslate(2.1, -1, 0)
		A3D_MatrixRotate(Sin($iGlobalTime / 3000/1.434), Sin($iGlobalTime / 3000/2.987), Sin($iGlobalTime / 3000/0.634))
;~ 		A3D_GeometryDraw($aGeoCubeTri)
		A3D_GeometryDraw($aGeoCubeQuad)
		A3D_MatrixPop()

		A3D_MatrixPush()
		A3D_MatrixTranslate(2.1, 1, 0)
		A3D_MatrixRotate(Sin($iGlobalTime / 3000/1.434), Sin($iGlobalTime / 3000/2.987), Sin($iGlobalTime / 3000/0.634))
		A3D_GeometryDraw($aGeoCubePoint)
		A3D_GeometryDraw($aGeoCubeLine)
		A3D_MatrixPop()

		A3D_EndScene($hBUF)

		DllCall($__g_hGDIPDll, "int", "GdipDrawImageI", "handle", $hGFX, "handle", $hBMP, "int", 0, "int", 0)

		$iFPS += 1
		If TimerDiff($iFpsTimer) > 1000 Then
;~ 			ConsoleWrite($A3D_DVA_COUNT & @CRLF)
			WinSetTitle($hGUI, '', 'Test@' & $iFPS & ', Vtx: ' & $A3D_DVA_COUNT & ' Point: ' & $A3D_DPA_COUNT & ', Line: ' & $A3D_DLA_COUNT & ', Tri: ' & $A3D_DTA_COUNT & ', Quad: ' & $A3D_DQA_COUNT)
			$iFPS = 0
			$iFpsTimer = TimerInit()
		EndIf
	WEnd

	_GDIPlus_GraphicsDispose($hBUF)
	_GDIPlus_BitmapDispose($hBMP)
	_GDIPlus_GraphicsDispose($hGFX)
	_GDIPlus_Shutdown()
EndFunc